﻿using System;

using Android.App;
using Android.Content;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.OS;
using Com.Rscja.Deviceapi;

namespace DemoM1
{
	[Activity (Label = "DemoM1", MainLauncher = true)]
	public class MainActivity : TabActivity
	{
		int count = 1;
		static RFIDWithISO14443A iso14443;
		TabHost tabhost=null;
		protected override void OnCreate (Bundle bundle)
		{
			base.OnCreate (bundle);

			// Set our view from the "main" layout resource
			SetContentView (Resource.Layout.Main);
			iso14443 = RFIDWithISO14443A.Instance;
			// Get our button from the layout resource,
			// and attach an event to it
			//Button button = FindViewById<Button> (Resource.Id.myButton);
			InitView ();
			//button.Click += delegate {
			//	button.Text = string.Format ("{0} clicks!", count++);
			//};
		}

		void InitView()
		{
			//	tabhost = FindViewById<TabHost> (Resource.Id.tabhost);// .tabHost1);
			CreateTab(typeof(Test), "test", "Test", Resource.Drawable.Icon);
			CreateTab(typeof(M1), "M1", "M1", Resource.Drawable.Icon);
			CreateTab(typeof(Ulartlight), "Ulartlight", "Ulartlight", Resource.Drawable.Icon);
			//CreateTab(typeof(Desfire), "Desfire", "Desfire", Resource.Drawable.Icon);
			CreateTab(typeof(Cpu), "Cpu", "Cpu", Resource.Drawable.Icon);
		
		}

		/// <summary>
		/// Creates the tab.
		/// </summary>
		/// <param name="activityType">类名</param>
		/// <param name="tag">Tag.</param>
		/// <param name="label">Label.</param>
		/// <param name="drawableId">Drawable identifier.</param>
		private void CreateTab(Type activityType, string tag, string label, int drawableId )
		{
			var intent = new Intent(this, activityType);
			intent.AddFlags(ActivityFlags.NewTask);

			var spec = TabHost.NewTabSpec(tag);
			var drawableIcon = Resources.GetDrawable(drawableId);
			spec.SetIndicator(label, drawableIcon);
			spec.SetContent(intent);

			TabHost.AddTab(spec);
		}

		protected override void OnResume()
		{
			base.OnResume ();
			new init14443 (this).Execute ();
		}
		protected override void OnPause()
		{
			base.OnPause ();
			if (iso14443 != null)
			{
				iso14443.Free();
			}
		}
		protected override void OnStop()
		{
			base.OnStop ();

		}


		public override bool OnKeyDown(Keycode code,KeyEvent e)
		{
			if (code == Keycode.F9)
			{
				//Scan ();
				return true;
			}
			return base.OnKeyDown (code,e);
		}
		public override bool OnKeyUp(Keycode code,KeyEvent e)
		{
			if (code == Keycode.F9)
			{

				return true;
			}
			return base.OnKeyUp (code,e);
		}


		public class init14443:AsyncTask{

			MainActivity mContext;
			ProgressDialog pro;
			public init14443(MainActivity m)
			{
				mContext=m;
			}

			protected override void OnPreExecute()
			{
				pro = new ProgressDialog (mContext);
				pro.SetProgressStyle (ProgressDialogStyle.Spinner);
				pro.SetMessage ("14443A Init...");
				pro.Show ();

			}
			#region implemented abstract members of AsyncTask

			protected override Java.Lang.Object DoInBackground (params Java.Lang.Object[] @params)
			{
				if (iso14443.Init()) 
				{//throw new NotImplementedException ();
					//mContext.StartScanThread ();
					PubClass.rfid = iso14443;
					return "OK";
				}
				return "";
			}

			#endregion
			protected override void  OnPostExecute(Java.Lang.Object obj)
			{
				if (obj.ToString() != "OK") {
					Toast.MakeText (mContext,"init failuer",ToastLength.Short).Show();
				}
				else
					Toast.MakeText (mContext,"init OK",ToastLength.Short).Show();
				pro.Cancel ();
			}

		}


	}
}


